Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/include/Select_Priority_Fixed.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/include/Select_Priority_Fixed.h	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/include/Select_Priority_Fixed.h	(revision 30)
@@ -19,4 +19,6 @@
 #include "Behavioural/Generic/Select/Select_Priority_Fixed/include/Parameters.h"
 #include "Behavioural/Generic/Select/Select_Priority_Fixed/include/Types.h"
+#include "Behavioural/include/Interfaces.h"
+
 #ifdef STATISTICS
 #include "Behavioural/Generic/Select/Select_Priority_Fixed/include/Statistics.h"
@@ -59,4 +61,6 @@
   private   : Vhdl_Testbench                 * _vhdl_testbench;
 #endif
+
+  private   : Interfaces                     * interfaces;
 
 #ifdef SYSTEMC
@@ -113,7 +117,7 @@
 #if VHDL				       
   public  : void     vhdl                      (void);
-  private : void     vhdl_port                 (Vhdl & vhdl);
-  private : void     vhdl_declaration          (Vhdl & vhdl);
-  private : void     vhdl_body                 (Vhdl & vhdl);
+  private : void     vhdl_port                 (Vhdl * & vhdl);
+  private : void     vhdl_declaration          (Vhdl * & vhdl);
+  private : void     vhdl_body                 (Vhdl * & vhdl);
 #endif					       
 					       
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed.cpp	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed.cpp	(revision 30)
@@ -32,4 +32,16 @@
     log_printf(FUNC,Select_Priority_Fixed,"Select_Priority_Fixed","Begin");
 
+#ifdef SYSTEMC
+    log_printf(INFO,Select_Priority_Fixed,"Select_Priority_Fixed","Allocation");
+
+    allocation ();
+#endif
+
+#ifdef POSITION
+    log_printf(INFO,Select_Priority_Fixed,"Select_Priority_Fixed","Position");
+    
+    
+#endif
+
 #ifdef STATISTICS
     log_printf(INFO,Select_Priority_Fixed,"Select_Priority_Fixed","Allocation of statistics");
@@ -48,5 +60,4 @@
     //  -> clock's signals
     _vhdl_testbench = new Vhdl_Testbench (_name);
-//     _vhdl_testbench->set_clock    ("in_CLOCK",false);
 #endif
 
@@ -58,13 +69,5 @@
 #endif
 
-#ifdef VHDL_TESTBENCH
-    _vhdl_testbench->set_clock    ("in_CLOCK",true);
-#endif
-
 #ifdef SYSTEMC
-    log_printf(INFO,Select_Priority_Fixed,"Select_Priority_Fixed","Allocation");
-
-    allocation ();
-
 #if defined(STATISTICS) or defined(VHDL_TESTBENCH)
     log_printf(INFO,Select_Priority_Fixed,"Select_Priority_Fixed","Method - transition");
@@ -98,5 +101,4 @@
     
 #endif    
-
 #endif
     log_printf(FUNC,Select_Priority_Fixed,"Select_Priority_Fixed","End");
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_allocation.cpp	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_allocation.cpp	(revision 30)
@@ -15,5 +15,4 @@
 namespace select_priority_fixed {
 
-
   void Select_Priority_Fixed::allocation (void)
   {
@@ -22,6 +21,11 @@
     log_printf(FUNC,Select_Priority_Fixed,"allocation","Begin");
 
-     in_CLOCK        = new SC_CLOCK           ("in_CLOCK ");
-     in_NRESET       = new SC_IN (Tcontrol_t) ("in_NRESET");
+    interfaces = new Interfaces;
+
+    // ~~~~~[ Interface : "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    Interface interface_ ("", IN, WEST);
+    
+    in_CLOCK        = interface_.set_signal_clk              ("clock" ,1, PORT_VHDL_YES_TESTBENCH_NO);
+    in_NRESET       = interface_.set_signal_in  <Tcontrol_t> ("nreset",1);
 
      in_VAL          = new SC_IN (Tcontrol_t)           * [_param._nb_entity];
@@ -31,19 +35,15 @@
     for (uint32_t i=0; i<_param._nb_entity; i++)
       {
-	rename = " in_VAL_"+toString(i);
-	 in_VAL [i]      = new SC_IN (Tcontrol_t) (rename.c_str());
-
+	 in_VAL [i]    = interface_.set_signal_in  <Tcontrol_t> ("val_"+toString(i),1);
 	if (_param._encoding_one_hot)
-	  {
-	rename = "out_ACK_"+toString(i);
-	out_ACK [i]      = new SC_OUT(Tcontrol_t) (rename.c_str());
-	  }
+	out_ACK [i]    = interface_.set_signal_out <Tcontrol_t> ("ack_"+toString(i),1);
       }
 
     if (_param._encoding_compact)
       {
-	out_ENTITY_ACK   = new SC_OUT(Tcontrol_t)           ("out_entity_ack");
-	out_ENTITY       = new SC_OUT(Tentity_t)            ("out_entity");
+	out_ENTITY     = interface_.set_signal_out <Tentity_t > ("entity"    , _param._size_entity);
+	out_ENTITY_ACK = interface_.set_signal_out <Tcontrol_t> ("entity_ack", 1);
       }
+
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
 
@@ -54,5 +54,4 @@
 }; // end namespace select
 }; // end namespace generic
-
 }; // end namespace behavioural
 }; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_deallocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_deallocation.cpp	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_deallocation.cpp	(revision 30)
@@ -40,4 +40,6 @@
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
 
+    delete interfaces;
+
     log_printf(FUNC,Select_Priority_Fixed,"deallocation","End");
   };
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_vhdl.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_vhdl.cpp	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_vhdl.cpp	(revision 30)
@@ -20,7 +20,8 @@
   {
     log_printf(FUNC,Select_Priority_Fixed,"vhdl","Begin");
-    Vhdl vhdl (_name);
 
-    vhdl.set_library_work (_name + "_Pack");
+    Vhdl * vhdl = new Vhdl (_name);
+
+    vhdl->set_library_work (_name + "_Pack");
 
     vhdl_port        (vhdl);
@@ -28,5 +29,5 @@
     vhdl_body        (vhdl);
 
-    vhdl.generate_file();
+    vhdl->generate_file();
     log_printf(FUNC,Select_Priority_Fixed,"vhdl","End");
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_vhdl_body.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_vhdl_body.cpp	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_vhdl_body.cpp	(revision 30)
@@ -16,28 +16,28 @@
 
 
-  void Select_Priority_Fixed::vhdl_body (Vhdl & vhdl)
+  void Select_Priority_Fixed::vhdl_body (Vhdl * & vhdl)
   {
     log_printf(FUNC,Select_Priority_Fixed,"vhdl_body","Begin");
-    vhdl.set_body ("");
+    vhdl->set_body ("");
 
-    vhdl.set_body("internal_entity <=");
+    vhdl->set_body("internal_entity <=");
     for (uint32_t i=0; i<_param._nb_entity; i++)
       {
-	vhdl.set_body("\t"+std_logic_conv(_param._size_entity+1,i)+" when in_VAL_"+toString(i)+"='1' else");
+	vhdl->set_body("\t"+std_logic_conv(_param._size_entity+1,i)+" when in_VAL_"+toString(i)+"='1' else");
       }
-    vhdl.set_body("\t"+std_logic_conv(_param._size_entity+1,1<<_param._size_entity)+";");
-    vhdl.set_body ("");
+    vhdl->set_body("\t"+std_logic_conv(_param._size_entity+1,1<<_param._size_entity)+";");
+    vhdl->set_body ("");
 
     if (_param._encoding_one_hot)
       {
 	for (uint32_t i=0; i<_param._nb_entity; i++)
-	  vhdl.set_body("out_ACK_"+toString(i)+" <= '1' when internal_entity"+std_logic_range(_param._size_entity+1)+" = "+std_logic_conv(_param._size_entity+1,i)+" else '0';");
-	vhdl.set_body ("");
+	  vhdl->set_body("out_ACK_"+toString(i)+" <= '1' when internal_entity"+std_logic_range(_param._size_entity+1)+" = "+std_logic_conv(_param._size_entity+1,i)+" else '0';");
+	vhdl->set_body ("");
       }
 
     if (_param._encoding_compact)
       {
-	vhdl.set_body ("out_ENTITY     <=     internal_entity"+std_logic_range(_param._size_entity-1,                  0)+";");
-	vhdl.set_body ("out_ENTITY_ACK <= not internal_entity"+std_logic_range(_param._size_entity  ,_param._size_entity)+";");
+	vhdl->set_body ("out_ENTITY     <=     internal_entity"+std_logic_range(_param._size_entity-1,                  0)+";");
+	vhdl->set_body ("out_ENTITY_ACK <= not internal_entity"+std_logic_range(_param._size_entity  ,_param._size_entity)+";");
       }	   
     
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_vhdl_declaration.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_vhdl_declaration.cpp	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_vhdl_declaration.cpp	(revision 30)
@@ -16,9 +16,9 @@
 
 
-  void Select_Priority_Fixed::vhdl_declaration (Vhdl & vhdl)
+  void Select_Priority_Fixed::vhdl_declaration (Vhdl * & vhdl)
   {
     log_printf(FUNC,Select_Priority_Fixed,"vhdl_declaration","Begin");
 
-    vhdl.set_signal("internal_entity",_param._size_entity+1);
+    vhdl->set_signal("internal_entity",_param._size_entity+1);
 
     log_printf(FUNC,Select_Priority_Fixed,"vhdl_declaration","End");
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_vhdl_port.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_vhdl_port.cpp	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_vhdl_port.cpp	(revision 30)
@@ -9,11 +9,5 @@
 #include "Behavioural/Generic/Select/Select_Priority_Fixed/include/Select_Priority_Fixed.h"
 
-#ifdef VHDL_TESTBENCH
-# define VHDL_SET_PORT(name,direction,size) do {vhdl.set_port (name,direction,size); _vhdl_testbench->set_port (name,direction,size);} while (0)
-#else
-# define VHDL_SET_PORT(name,direction,size)     vhdl.set_port (name,direction,size)
-#endif
-
-namespace morpheo                    {
+namespace morpheo {
 namespace behavioural {
 namespace generic {
@@ -21,24 +15,17 @@
 namespace select_priority_fixed {
 
-
-  void Select_Priority_Fixed::vhdl_port (Vhdl & vhdl)
+  void Select_Priority_Fixed::vhdl_port (Vhdl * & vhdl)
   {
     log_printf(FUNC,Select_Priority_Fixed,"vhdl_port","Begin");
 
-    vhdl.set_port (" in_CLOCK ", IN, 1);
-    VHDL_SET_PORT (" in_NRESET", IN, 1);
-	
-    for (uint32_t i=0; i<_param._nb_entity; i++)
-      {
-	VHDL_SET_PORT (" in_VAL_"+toString(i) , IN, 1);
-	if (_param._encoding_one_hot)
-	VHDL_SET_PORT ("out_ACK_"+toString(i) ,OUT, 1);
-      }
-    if (_param._encoding_compact)
-      {
-    VHDL_SET_PORT ("out_ENTITY    ",OUT,_param._size_entity);
-    VHDL_SET_PORT ("out_ENTITY_ACK",OUT,1);
-      }
-    log_printf(FUNC,Select_Priority_Fixed,"vhdl_port","End");
+#ifdef VHDL
+    interfaces->set_port(vhdl);
+#endif
+#ifdef VHDL_TESTBENCH
+    interfaces->set_port(_vhdl_testbench);			
+   _vhdl_testbench->set_clock    ("in_CLOCK",true);
+#endif    
+
+   log_printf(FUNC,Select_Priority_Fixed,"vhdl_port","End");
   };
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/Makefile	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/Makefile	(revision 30)
@@ -8,5 +8,6 @@
 
 #-----[ Directory ]----------------------------------------
-DIR_MORPHEO			= ../../..
+DIR_COMPONENT			= .
+include				$(DIR_COMPONENT)/Makefile.defs
 
 #-----[ Library ]------------------------------------------
@@ -19,5 +20,5 @@
 				@$(MAKE) all_component
 
-include                         $(DIR_MORPHEO)/Behavioural/Makefile.defs
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
 include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
 include				$(DIR_MORPHEO)/Behavioural/Makefile.Component
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/Makefile.defs
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/Makefile.defs	(revision 30)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/Makefile.defs	(revision 30)
@@ -0,0 +1,11 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT_MORPHEO		= ../../..
+DIR_MORPHEO			= $(DIR_COMPONENT)/$(DIR_COMPONENT_MORPHEO)
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/Makefile	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/Makefile	(revision 30)
@@ -24,5 +24,5 @@
 
 include                         ../Makefile.deps
-include                         $(DIR_MORPHEO)/Behavioural/Makefile.defs
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
 include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
 include				$(DIR_MORPHEO)/Behavioural/Makefile.Selftest
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/doc/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/doc/Makefile	(revision 30)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/doc/Makefile	(revision 30)
@@ -0,0 +1,19 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ../
+include				$(DIR_COMPONENT)/Makefile.defs
+
+#-----[ include ]------------------------------------------
+
+all				:
+				$(MAKE) all_documentation
+
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Documentation
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/Makefile	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/Makefile	(revision 30)
@@ -8,5 +8,6 @@
 
 #-----[ Directory ]----------------------------------------
-DIR_MORPHEO			= ../../../..
+DIR_COMPONENT			= .
+include				$(DIR_COMPONENT)/Makefile.defs
 
 #-----[ Library ]------------------------------------------
@@ -18,5 +19,5 @@
 				@$(MAKE) all_component
 
-include                         $(DIR_MORPHEO)/Behavioural/Makefile.defs
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
 include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
 include				$(DIR_MORPHEO)/Behavioural/Makefile.Component
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/Makefile.defs
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/Makefile.defs	(revision 30)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/Makefile.defs	(revision 30)
@@ -0,0 +1,11 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT_MORPHEO		= ../../../..
+DIR_MORPHEO			= $(DIR_COMPONENT)/$(DIR_COMPONENT_MORPHEO)
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/SelfTest/Makefile	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/SelfTest/Makefile	(revision 30)
@@ -24,5 +24,5 @@
 
 include                         ../Makefile.deps
-include                         $(DIR_MORPHEO)/Behavioural/Makefile.defs
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
 include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
 include				$(DIR_MORPHEO)/Behavioural/Makefile.Selftest
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/doc/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/doc/Makefile	(revision 30)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/doc/Makefile	(revision 30)
@@ -0,0 +1,19 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ../
+include				$(DIR_COMPONENT)/Makefile.defs
+
+#-----[ include ]------------------------------------------
+
+all				:
+				$(MAKE) all_documentation
+
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Documentation
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile	(revision 30)
@@ -8,5 +8,6 @@
 
 #-----[ Directory ]----------------------------------------
-DIR_MORPHEO			= ../
+DIR_COMPONENT                   = ./
+include                         $(DIR_COMPONENT)/Makefile.defs
 
 #-----[ Library ]------------------------------------------
@@ -18,5 +19,5 @@
 				@$(MAKE) all_component
 
-include                         $(DIR_MORPHEO)/Behavioural/Makefile.defs
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
 include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
 include				$(DIR_MORPHEO)/Behavioural/Makefile.Component
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.Component
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.Component	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.Component	(revision 30)
@@ -1,9 +1,11 @@
-#-----[ Variable ]-----------------------------------------
+#-----[ Directory ]----------------------------------------
+DIR_DOC				= doc
 DIR_LIB				= lib
 DIR_TEST			= SelfTest
 
+#-----[ Variable ]-----------------------------------------
 OBJECTS				= $(OBJECTS_COMMON)
 
-#-----[ Directory ]----------------------------------------
+#-----[ Rules ]--------------------------------------------
 .PRECIOUS			: $(DIR_LIB)/%.a
 .NOPARALLEL			: clean help
@@ -21,4 +23,7 @@
 				@$(MKDIR) $@
 
+document			:
+				@$(MAKE) --directory=$(DIR_DOC) --makefile=Makefile
+
 component_clean			:
 				@$(RM) $(DIR_LIB)
@@ -28,4 +33,5 @@
 				@$(ECHO) ""
 				@$(ECHO) " * all_component        : compile all c++ file and generate library"
+				@$(ECHO) " * document             : Generate documantation"
 				@$(ECHO) " * clean                : Erase all generate files"
 				@$(ECHO) " * help                 : print this text"
@@ -39,3 +45,3 @@
 				@$(MAKE) common_clean 
 				@$(MAKE) component_clean
-
+				@if $(TEST) -d $(DIR_DOC); then $(MAKE) --directory=$(DIR_DOC) --makefile=Makefile clean; fi
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.Documentation
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.Documentation	(revision 30)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.Documentation	(revision 30)
@@ -0,0 +1,116 @@
+#-----[ Directory ]----------------------------------------
+
+DIR_DOCUMENTATION       = .
+DIR_TEX   	        = $(DIR_DOCUMENTATION)
+DIR_SCHEMA              = $(DIR_DOCUMENTATION)/fig
+DIR_SCHEMA_EPS          = $(DIR_DOCUMENTATION)/eps
+
+#-----[ Files ]--------------------------------------------
+
+TEX_FILES               = $(wildcard $(DIR_TEX)/*.tex)
+DVI_FILES               = $(patsubst $(DIR_TEX)/%.tex,%.dvi,$(TEX_FILES))
+PS_FILES                = $(patsubst $(DIR_TEX)/%.tex,%.ps ,$(TEX_FILES))
+PDF_FILES               = $(patsubst $(DIR_TEX)/%.tex,%.pdf,$(TEX_FILES))
+EPS_FILES               = $(patsubst $(DIR_SCHEMA)/%.fig,$(DIR_SCHEMA_EPS)/%.eps,$(wildcard $(DIR_SCHEMA)/*.fig))       \
+                          $(patsubst $(DIR_SCHEMA)/%.eps,$(DIR_SCHEMA_EPS)/%.eps,$(wildcard $(DIR_SCHEMA)/*.eps))
+
+#-----[ Rules ]--------------------------------------------
+
+#--------------------------------------------------------------------------------
+# The reset of this file shall not be editted
+#--------------------------------------------------------------------------------
+.PHONY 			: all clean help
+.SECONDARY 		: $(DVI_FILES) $(PS_FILES) $(PDF_FILES) $(EPS_FILES) $(DIR_SCHEMA_EPS)
+
+all_documentation	: $(EPS_FILES)
+			$(MAKE) $(PDF_FILES)
+
+#--------------------------------------------------------------------------------
+# Generation of the formatted text:
+# regular flow tex -> dvi -> ps -> pdf.
+#--------------------------------------------------------------------------------
+%.pdf 			: %.ps
+			@$(ECHO) "Génération du fichier $*.pdf"
+			@$(PS2PDF) $< $@
+			@#Copy at directory
+
+%.ps 			: %.dvi
+			@$(ECHO) "Génération du fichier $*.ps"
+			@$(DVIPS) -o $@ $<
+
+%.dvi 			: $(DIR_TEX)/%.tex
+			@$(ECHO) "Génération du fichier $*.dvi"
+			@#touch $(patsubst %.tex,%.ind,$<)
+			@$(LATEX) $<
+			@$(LATEX) $< > /dev/null
+			@#$(MAKEINDEX) $(patsubst %.tex,%.idx,$<)
+			@citation=`$(GREP) "citation" $*.aux`; \
+	                 if $(TEST) -n "$$citation" ; then  \
+			  $(BIBTEX) $* ; \
+			fi
+			@$(LATEX) $< > /dev/null
+			@$(LATEX) $< > /dev/null
+
+#--------------------------------------------------------------------------------
+# The figures directory
+#--------------------------------------------------------------------------------
+$(DIR_SCHEMA_EPS)	:
+			@$(ECHO) "Make directory       : $@"
+			@$(MKDIR) $@
+
+$(DIR_SCHEMA_EPS)/%.eps	: $(DIR_SCHEMA)/%.eps $(DIR_SCHEMA_EPS)
+			@$(ECHO) "Generate   files     : $*.eps"
+			@$(CP) $(DIR_SCHEMA)/$*.eps $(DIR_SCHEMA_EPS)
+
+$(DIR_SCHEMA_EPS)/%.eps	: $(DIR_SCHEMA)/%.fig $(DIR_SCHEMA_EPS)
+			@$(ECHO) "Generate   files     : $*.eps"
+			@$(FIG2EPS) $< $@
+
+#--------------------------------------------------------------------------------
+# Cleaning
+#--------------------------------------------------------------------------------
+
+clean			:
+			@$(ECHO) "Delete     temporary files              "$(PWD)
+			@$(RM) $(DIR_SCHEMA_EPS)
+			@$(RM) $(DVI_FILES) $(PS_FILES) $(PDF_FILES)
+			@$(MAKE) clean_rec DIR_CLEAN=.  
+
+#Clean recursive
+clean_rec		:
+			@$(ECHO) "Delete     temporary files in directory $(DIR_CLEAN)"
+			@$(RM)	$(DIR_CLEAN)/*~ 		\
+				$(DIR_CLEAN)/*.bak  		\
+				$(DIR_CLEAN)/*.aux  		\
+				$(DIR_CLEAN)/*.bbl  		\
+				$(DIR_CLEAN)/*.blg  		\
+				$(DIR_CLEAN)/*.bmt  		\
+				$(DIR_CLEAN)/*.log  		\
+				$(DIR_CLEAN)/*.mtc* 		\
+				$(DIR_CLEAN)/*.toc  		\
+				$(DIR_CLEAN)/*.idx  		\
+				$(DIR_CLEAN)/*.ilg  		\
+				$(DIR_CLEAN)/*.ind  		\
+				$(DIR_CLEAN)/*.out  		\
+				$(DIR_CLEAN)/*.nav  		\
+				$(DIR_CLEAN)/*.snm  		\
+				$(DIR_CLEAN)/missfont.log
+			@# The .bbl file is to be removed if "bibtex" is used.
+			@for files in `$(LS) $(DIR_CLEAN)`; do                              			\
+				if $(TEST) -d $(DIR_CLEAN)/$$files;                         			\
+				then                                                        			\
+					$(MAKE) clean_rec DIR_CLEAN=$(DIR_CLEAN)/$$files;   			\
+				fi;                                                         			\
+			done;
+
+#--------------------------------------------------------------------------------
+# Help
+#--------------------------------------------------------------------------------
+
+help			:
+			@$(ECHO) " -----[ Documentation ]------------------------------"
+			@$(ECHO) ""
+			@$(ECHO) " * all_documentation    : Generate all documents"
+			@$(ECHO) " * clean                : Erase all generate files"
+			@$(ECHO) " * help                 : Print this message"
+			@$(ECHO) ""
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.defs
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.defs	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.defs	(revision 30)
@@ -4,27 +4,6 @@
 # [ Description ]
 # 
-# Makefile
 
-#-----[ Simulator ]----------------------------------------
-SIMULATOR			= systemcass_deps
-
-# 3 simulators :
-# systemc			- SystemC    
-# systemcass 			- SystemCASS
-# systemcass_deps		- SystemCASS, and use port dependency information instead of sensitivity list
-
-#-----[ Flags ]--------------------------------------------
-FLAGS				=	-DVHDL			\
- 					-DVHDL_TESTBENCH	\
-					-DSYSTEMC		\
-					-DSTATISTICS 		\
-					-DCONFIGURATION		\
-					-DDEBUG=DEBUG_ALL    
-					
-# Flags :
-# DEBUG={level}                 - Print Debug Message
-# VHDL                          - To generate a vhdl's    model
-# SYSTEMC                       - To generate a systemc's model
-# CONFIGURATION			- To generate a configuration file (it's input of viewer)
-# STATISTICS     (need SYSTEMC) - In the simulation, generate a statistics's file
-# VHDL_TESTBENCH (need SYSTEMC) - In the simulation, generate two testbench's file (input and ouput) to validate the vhdl's model
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT_MORPHEO           = ..
+DIR_MORPHEO                     = $(DIR_COMPONENT)/$(DIR_COMPONENT_MORPHEO)
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.flags
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.flags	(revision 30)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.flags	(revision 30)
@@ -0,0 +1,31 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+
+#-----[ Simulator ]----------------------------------------
+SIMULATOR			= systemcass_deps
+
+# 3 simulators :
+# systemc			- SystemC    
+# systemcass 			- SystemCASS
+# systemcass_deps		- SystemCASS, and use port dependency information instead of sensitivity list
+
+#-----[ Flags ]--------------------------------------------
+FLAGS				=	-DSYSTEMC		\
+					-DVHDL			\
+ 					-DVHDL_TESTBENCH	\
+					-DSTATISTICS 		\
+					-DPOSITION       	\
+					-DCONFIGURATION  	\
+					-DDEBUG=DEBUG_ALL    
+					
+# Flags :
+# DEBUG={level}                 - Print Debug Message
+# SYSTEMC                       - To generate a systemc's model
+# VHDL                          - To generate a vhdl's    models
+# VHDL_TESTBENCH (need SYSTEMC) - In the simulation, generate two testbench's file (input and ouput) to validate the vhdl's model
+# STATISTICS     (need SYSTEMC) - In the simulation, generate a statistics's file
+# POSITION                      - To generate a position's files     (it's input of viewer)
+# CONFIGURATION			- To generate a configuration's file (it's input of viewer and generator)
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.mkf
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.mkf	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.mkf	(revision 30)
@@ -3,20 +3,17 @@
 #
 
-all: _Generic/RegisterFile/SelfTest _Generic/Select/Priority_Fixed/SelfTest
+all: _Generic/RegisterFile/RegisterFile_Monolithic/SelfTest Generic/Select/Priority_Fixed/SelfTest
 
-_Generic/RegisterFile/SelfTest:
-	gmake all -C Generic/RegisterFile/SelfTest
+_Generic/RegisterFile/RegisterFile_Monolithic/SelfTest:
+	gmake all -C Generic/RegisterFile/RegisterFile_Monolithic/SelfTest
 
-_Generic/Select/Priority_Fixed/SelfTest:
-	gmake all -C Generic/Select/Priority_Fixed/SelfTest
+Generic/Select/Priority_Fixed/SelfTest:
 
 clean:
-	gmake clean -C Generic/RegisterFile/SelfTest
-	gmake clean -C Generic/Select/Priority_Fixed/SelfTest
+	gmake clean -C Generic/RegisterFile/RegisterFile_Monolithic/SelfTest
 
 re: clean all
 
 install:
-	gmake install -C Generic/RegisterFile/SelfTest
-	gmake install -C Generic/Select/Priority_Fixed/SelfTest
+	gmake install -C Generic/RegisterFile/RegisterFile_Monolithic/SelfTest
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/Makefile	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/Makefile	(revision 30)
@@ -8,5 +8,6 @@
 
 #-----[ Directory ]----------------------------------------
-DIR_MORPHEO			= @DIR_MORPHEO
+DIR_COMPONENT			= ./
+include				$(DIR_COMPONENT)/Makefile.defs
 
 #-----[ Library ]------------------------------------------
@@ -19,5 +20,5 @@
 				@$(MAKE) all_component
 
-include                         $(DIR_MORPHEO)/Behavioural/Makefile.defs
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
 include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
 include				$(DIR_MORPHEO)/Behavioural/Makefile.Component
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/Makefile.defs
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/Makefile.defs	(revision 30)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/Makefile.defs	(revision 30)
@@ -0,0 +1,11 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT_MORPHEO		= @DIR_MORPHEO
+DIR_MORPHEO			= $(DIR_COMPONENT)/$(DIR_COMPONENT_MORPHEO)
